#!/usr/bin/perl -w
 #######################################################################
 # Copyright 2007 - 2009 Igor Daniloff.
 # 
 # Following source code is the property of Doctor Web, Ltd.
 # Use is subject to license terms.
 # The reproduction in any form without written permission of
 # Doctor Web, Ltd. and proper attribution is strongly prohibited.
 # 
 # Author: $Author: ai $
 # Date: $Date: 2009/12/14 13:53:09 $
 # Revision: $Revision: 1.8 $
 #######################################################################

use File::Basename;
use lib "dirname($0)";
use lib "/opt/drweb/maild/scripts";
use lib "/usr/local/drweb/maild/scripts";

use Data::Dumper;

use dwplugins;
use dwconfig;

my %my_lng=(
    'Address' => 'Enter address of Dr.Web antivirus daemon:',
    'daemon'=>'Please, check that drwebd already installed.',
    
    'Address_l'=>'Drwebd address',
    );

my $name = "drweb";
my $can_before_queue = undef;
my $name_in_key = "DrWebAntiVirus";

my $specific = sub {
    my ($maild,$maild_old,$my_conf) = @_;

    my $Address='pid:/var/drweb/run/drwebd.pid';
    my $Address_def=$Address;
    my $change_list;

    my $enter = sub{
      REENTER:
        $change_list = [];
        $maild = AddPlugin($maild_old,$name,$can_before_queue,\$change_list);

      REENTER1:
        DwEnterString($my_lng{'Address'},\$Address);
        my @Address = map {/^\s*(.*?)\s*$/}  split (/,/,$Address);
        foreach my $a (@Address){
            if($a !~ /^((inet:\d+@)|local:|pid:)\S+/){
                print sprintf "\n".$lng{'wrong_addr'}."\n", $a;
                $Address=$Address_def;
                goto REENTER1;
            }else{
                if($a =~ /^pid:(.*)$/ && -f $1 && ! -r $1){
                    print sprintf("\n".$lng{'wrong_pid'}."\n".$my_lng{'daemon'}."\n",
                                 $1) ;
                    $Address=$Address_def;
                    goto REENTER1;
                }
            }
        }
        push @$change_list, $my_lng{'Address_l'}." = ".$Address;
    };

    DwEnterConfig($enter,\$change_list);

    $my_conf = DwModify($my_conf,"Antivirus","Address",$Address,"vector");
    
    return ($maild,$my_conf);
};

DwPluginInstallationFramework($name,$specific,$can_before_queue,$name_in_key);
